Index: lib/style/skins/metacatui/iso/iso-ci.xsl
===================================================================
--- lib/style/skins/metacatui/iso/iso-ci.xsl	(revision 10058)
+++ lib/style/skins/metacatui/iso/iso-ci.xsl	(revision 10059)
@@ -278,5 +278,156 @@
     </xsl:if>
   </xsl:template>
 
-  
+    <xsl:template match="gmd:CI_Citation">
+        <div class="control-group">
+            <label class="control-label">Title</label>
+            <div class="controls">
+                <div class="controls-well">
+                    <xsl:apply-templates select="./gmd:title" />
+                </div>
+            </div>
+        </div>
+
+        <xsl:if test="./gmd:alternateTitle">
+            <xsl:for-each select="./gmd:alternateTitle">
+                <div class="control-group">
+                    <label class="control-label">Alternate Title</label>
+                    <div class="controls">
+                        <div class="controls-well">
+                            <xsl:apply-templates />
+                        </div>
+                    </div>
+                </div>
+            </xsl:for-each>
+        </xsl:if>
+
+        <xsl:for-each select="./gmd:date">
+            <div class="control-group">
+                <label class="control-label">Date</label>
+                <div class="controls">
+                    <div class="controls-well">
+                        <xsl:apply-templates />
+                    </div>
+                </div>
+            </div>
+        </xsl:for-each>
+
+        <xsl:if test="./gmd:edition">
+            <xsl:for-each select="./gmd:edition">
+                <div class="control-group">
+                    <label class="control-label">Edition</label>
+                    <div class="controls">
+                        <div class="controls-well">
+                            <xsl:apply-templates />
+                        </div>
+                    </div>
+                </div>
+            </xsl:for-each>
+        </xsl:if>
+
+        <xsl:if test="./gmd:editionDate">
+            <div class="control-group">
+                <label class="control-label">Edition Date</label>
+                <div class="controls">
+                    <div class="controls-well">
+                        <xsl:apply-templates />
+                    </div>
+                </div>
+            </div>
+        </xsl:if>
+
+        <xsl:if test="./gmd:identifier">
+            <xsl:for-each select="./gmd:identifier">
+                <div class="control-group">
+                    <label class="control-label">Identifier</label>
+                    <div class="controls">
+                        <div class="controls-well">
+                            <xsl:apply-templates />
+                        </div>
+                    </div>
+                </div>
+            </xsl:for-each>
+        </xsl:if>
+
+        <xsl:if test="./gmd:citedResponsibleParty">
+            <xsl:for-each select="./gmd:citedResponsibleParty">
+                <div class="control-group">
+                    <label class="control-label">Cited Responsible Party</label>
+                    <div class="controls">
+                        <div class="controls-well">
+                            <xsl:apply-templates />
+                        </div>
+                    </div>
+                </div>
+            </xsl:for-each>
+        </xsl:if>
+
+        <xsl:if test="./gmd:presentationForm">
+            <xsl:for-each select="./gmd:presentationForm">
+                <div class="control-group">
+                    <label class="control-label">Presentation Form</label>
+                    <div class="controls">
+                        <div class="controls-well">
+                            <xsl:apply-templates />
+                        </div>
+                    </div>
+                </div>
+            </xsl:for-each>
+        </xsl:if>
+
+        <xsl:if test="./gmd:series">
+            <div class="control-group">
+                <label class="control-label">Series</label>
+                <div class="controls">
+                    <div class="controls-well">
+                        <xsl:apply-templates />
+                    </div>
+                </div>
+            </div>
+        </xsl:if>
+
+        <xsl:if test="./gmd:otherCitationDetails">
+            <div class="control-group">
+                <label class="control-label">Other Citation Details</label>
+                <div class="controls">
+                    <div class="controls-well">
+                        <xsl:apply-templates />
+                    </div>
+                </div>
+            </div>
+        </xsl:if>
+
+        <xsl:if test="./gmd:collectiveTitle">
+            <div class="control-group">
+                <label class="control-label">Collective Title</label>
+                <div class="controls">
+                    <div class="controls-well">
+                        <xsl:apply-templates />
+                    </div>
+                </div>
+            </div>
+        </xsl:if>
+
+        <xsl:if test="./gmd:ISBN">
+            <div class="control-group">
+                <label class="control-label">ISBN</label>
+                <div class="controls">
+                    <div class="controls-well">
+                        <xsl:apply-templates />
+                    </div>
+                </div>
+            </div>
+        </xsl:if>
+
+        <xsl:if test="./gmd:ISSN">
+            <div class="control-group">
+                <label class="control-label">ISSN</label>
+                <div class="controls">
+                    <div class="controls-well">
+                        <xsl:apply-templates />
+                    </div>
+                </div>
+            </div>
+        </xsl:if>
+    </xsl:template>
 </xsl:stylesheet>
\ No newline at end of file
Index: lib/style/skins/metacatui/iso/iso-ex.xsl
===================================================================
--- lib/style/skins/metacatui/iso/iso-ex.xsl	(revision 10058)
+++ lib/style/skins/metacatui/iso/iso-ex.xsl	(revision 10059)
@@ -5,11 +5,6 @@
   xmlns:gco="http://www.isotc211.org/2005/gco" 
   xmlns:gml="http://www.opengis.net/gml/3.2" version="1.0">
 
-  <xsl:output method="html" encoding="UTF-8"
-      doctype-public="-//W3C//DTD XHTML 1.0 Transitional//EN"
-      doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"
-      indent="yes" />
-
     <xsl:template match="gmd:EX_Extent">
       <h4>Extent</h4>
 
@@ -83,7 +78,7 @@
   <xsl:template match="gmd:EX_GeographicBoundingBox">
     <!-- Set up variables for N E S W -->
     <xsl:variable name="north"><xsl:value-of select="./gmd:northBoundLatitude/gco:Decimal/text()" /></xsl:variable>
-    <xsl:variable name="east"><xsl:value-of select="./gmd:eastBoundLongitude/gco:Decimal/text())" /></xsl:variable>
+    <xsl:variable name="east"><xsl:value-of select="./gmd:eastBoundLongitude/gco:Decimal/text()" /></xsl:variable>
     <xsl:variable name="south"><xsl:value-of select="./gmd:southBoundLatitude/gco:Decimal/text()" /></xsl:variable>
     <xsl:variable name="west"><xsl:value-of select="./gmd:westBoundLongitude/gco:Decimal/text()" /></xsl:variable>
 
Index: lib/style/skins/metacatui/iso/iso-gco.xsl
===================================================================
--- lib/style/skins/metacatui/iso/iso-gco.xsl	(nonexistent)
+++ lib/style/skins/metacatui/iso/iso-gco.xsl	(revision 10059)
@@ -0,0 +1,20 @@
+<?xml version="1.0"?>
+<xsl:stylesheet
+        xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
+        xmlns:gco="http://www.isotc211.org/2005/gco"
+        version="1.0">
+    <!-- TODO: gco:Date-->
+    <!-- TODO: gco:DateTime-->
+
+    <xsl:template match="gco:CharacterString">
+        <xsl:value-of select="." />
+    </xsl:template>
+
+    <xsl:template match="gco:Date">
+        <xsl:value-of select="." />
+    </xsl:template>
+
+    <xsl:template match="gco:DateTime">
+        <xsl:value-of select="." />
+    </xsl:template>
+</xsl:stylesheet>
Index: lib/style/skins/metacatui/iso/iso-gmd.xsl
===================================================================
--- lib/style/skins/metacatui/iso/iso-gmd.xsl	(nonexistent)
+++ lib/style/skins/metacatui/iso/iso-gmd.xsl	(revision 10059)
@@ -0,0 +1,16 @@
+<?xml version="1.0"?>
+<xsl:stylesheet
+        xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
+        xmlns:gmd="http://www.isotc211.org/2005/gmd"
+        version="1.0">
+
+    <xsl:template match="gmd:URL">
+        <xsl:variable name="url"><xsl:value-of select="./text()" /></xsl:variable>
+        <xsl:element name="a">
+            <xsl:attribute name="href">
+                <xsl:value-of select="$url" />
+            </xsl:attribute>
+            <xsl:value-of select="$url" />
+        </xsl:element>
+    </xsl:template>
+</xsl:stylesheet>
\ No newline at end of file
Index: lib/style/skins/metacatui/iso/iso-gml.xsl
===================================================================
--- lib/style/skins/metacatui/iso/iso-gml.xsl	(revision 10058)
+++ lib/style/skins/metacatui/iso/iso-gml.xsl	(revision 10059)
@@ -3,11 +3,6 @@
         xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
         xmlns:gml="http://www.opengis.net/gml/3.2" version="1.0">
 
-    <xsl:output method="html" encoding="UTF-8"
-                doctype-public="-//W3C//DTD XHTML 1.0 Transitional//EN"
-                doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"
-                indent="yes" />
-
     <xsl:template match="gml:Point">
 
     </xsl:template>
Index: lib/style/skins/metacatui/iso/iso-gmx.xsl
===================================================================
--- lib/style/skins/metacatui/iso/iso-gmx.xsl	(nonexistent)
+++ lib/style/skins/metacatui/iso/iso-gmx.xsl	(revision 10059)
@@ -0,0 +1,24 @@
+<?xml version="1.0"?>
+<xsl:stylesheet
+        xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
+        xmlns:gmx="http://www.isotc211.org/2005/gmx"
+        xmlns:xlink="http://www.w3.org/1999/xlink"
+        version="1.0">
+
+    <xsl:template match="gmx:Anchor">
+        <xsl:element name="a">
+            <xsl:attribute name="href">
+                <xsl:value-of select="./@xlink:href" />
+            </xsl:attribute>
+
+            <!-- Create the attributes for a Bootstrap tooltip to hold the title -->
+            <xsl:if test="./@xlink:title">
+                <xsl:attribute name="data-toggle">tooltip</xsl:attribute>
+                <xsl:attribute name="data-placement">top</xsl:attribute>
+                <xsl:attribute name="title"><xsl:value-of select="./@xlink:title" /></xsl:attribute>
+            </xsl:if>
+
+            <xsl:value-of select="./text()" />
+        </xsl:element>
+    </xsl:template>
+</xsl:stylesheet>
Index: lib/style/skins/metacatui/iso/iso-md.xsl
===================================================================
--- lib/style/skins/metacatui/iso/iso-md.xsl	(revision 10058)
+++ lib/style/skins/metacatui/iso/iso-md.xsl	(revision 10059)
@@ -2,7 +2,6 @@
 <xsl:stylesheet
   xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
   xmlns:gmd="http://www.isotc211.org/2005/gmd"
-  xmlns:gco="http://www.isotc211.org/2005/gco" 
   version="1.0">
 
   <xsl:template match="gmd:MD_Identifier">
@@ -9,14 +8,48 @@
     <xsl:apply-templates select="./gmd:code" />
   </xsl:template>
 
+    <xsl:template match="gmd:MD_TopicCategoryCode">
+        <xsl:apply-templates />
+    </xsl:template>
+
   <xsl:template match="gmd:MD_Keywords">
-    <div><strong>Type:</strong>&#xa0;<xsl:value-of select="./gmd:type/gmd:MD_KeywordTypeCode/text()" /></div>
-    <div><strong>Thesaurus:&#xa0;</strong><xsl:value-of select="./gmd:thesaurusName/gmd:CI_Citation/gmd:title/gco:CharacterString/text()" /></div>
+      <table class="table table-condensed">
+          <thead>
+              <tr>
+                  <th>Keyword</th>
+              </tr>
+          </thead>
+          <tbody>
+              <xsl:for-each select="./gmd:keyword">
+                  <tr>
+                    <td><xsl:apply-templates select="." /></td>
+                  </tr>
+              </xsl:for-each>
+          </tbody>
+      </table>
 
-    <ul>
-      <xsl:for-each select="./gmd:keyword">
-        <li><xsl:apply-templates select="." /></li>
-      </xsl:for-each>
-    </ul>
+      <xsl:if test="./gmd:type">
+          <div class="control-group">
+              <label class="control-label">Type</label>
+              <div class="controls">
+                  <div class="controls-well">
+                      <xsl:value-of select="./gmd:type/gmd:MD_KeywordTypeCode/text()" />
+                  </div>
+              </div>
+          </div>
+      </xsl:if>
+
+      <div class="control-group">
+          <label class="control-label">Thesaurus</label>
+          <div class="controls">
+              <div class="controls-well">
+                  <xsl:apply-templates select="./gmd:thesaurusName/gmd:CI_Citation" />
+              </div>
+          </div>
+      </div>
+
   </xsl:template>
+
+    <!-- TODO: gmd:CI_PresentationFormCode-->
+    <!-- TODO: gmd:CI_Series -->
 </xsl:stylesheet>
\ No newline at end of file
Index: lib/style/skins/metacatui/iso/isoroot.xsl
===================================================================
--- lib/style/skins/metacatui/iso/isoroot.xsl	(revision 10058)
+++ lib/style/skins/metacatui/iso/isoroot.xsl	(revision 10059)
@@ -3,14 +3,15 @@
   xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
   xmlns:gmd="http://www.isotc211.org/2005/gmd" 
   xmlns:gco="http://www.isotc211.org/2005/gco" 
-  xmlns:gmx="http://www.isotc211.org/2005/gmx"
-  xmlns:gml="http://www.opengis.net/gml/3.2" 
-  xmlns:xlink="http://www.w3.org/1999/xlink"
   version="1.0">
 
+  <xsl:import href="iso-md.xsl"/>
   <xsl:import href="iso-ci.xsl"/>
   <xsl:import href="iso-ex.xsl"/>
-  <xsl:import href="iso-md.xsl"/>
+  <xsl:import href="iso-gco.xsl"/>
+  <xsl:import href="iso-gmd.xsl"/>
+  <xsl:import href="iso-gml.xsl"/>
+  <xsl:import href="iso-gmx.xsl"/>
 
   <xsl:output method="html" encoding="UTF-8"
       doctype-public="-//W3C//DTD XHTML 1.0 Transitional//EN"
@@ -85,11 +86,20 @@
             <label class="control-label">Topic Categories</label>
             <div class="controls">
               <div class="controls-well">
-                <ul>
-                  <xsl:for-each select="//gmd:topicCategory">
-                    <li><xsl:value-of select="./gmd:MD_TopicCategoryCode/text()" /></li>                
-                  </xsl:for-each>
-                </ul>
+                <table class="table table-condensed">
+                  <thead>
+                    <tr>
+                      <th>Topic</th>
+                    </tr>
+                  </thead>
+                  <tbody>
+                    <xsl:for-each select="//gmd:topicCategory">
+                      <tr>
+                        <td><xsl:apply-templates /></td>
+                      </tr>
+                    </xsl:for-each>
+                  </tbody>
+                </table>
               </div>
             </div>
           </div>
@@ -166,39 +176,9 @@
 
   <!-- TODO: Figure out how to do this: I want to capture the scenario where
   an element like gmd:individualName has on child gco:CharacterString or 
-  equivalent but has a nilReasona attribute. -->
-  <xsl:template match="@nilReason">
+  equivalent but has a nilReason attribute. -->
+  <xsl:template match="*[not(*) and ./@nilReason]">
+    nilReason!
     <xsl:value-of select="@nilReason" />
   </xsl:template>
-
-  <xsl:template match="gco:CharacterString">
-    <xsl:value-of select="." />
-  </xsl:template>
-
-  <xsl:template match="gmx:Anchor">
-    <xsl:element name="a">
-      <xsl:attribute name="href">
-        <xsl:value-of select="./@xlink:href" />
-      </xsl:attribute>
-
-      <!-- Create the attributes for a Bootstrap tooltip to hold the title -->
-      <xsl:if test="./@xlink:title">
-        <xsl:attribute name="data-toggle">tooltip</xsl:attribute>
-        <xsl:attribute name="data-placement">top</xsl:attribute>
-        <xsl:attribute name="title"><xsl:value-of select="./@xlink:title" /></xsl:attribute>
-      </xsl:if>
-
-      <xsl:value-of select="./text()" />
-    </xsl:element>
-  </xsl:template>
-
-  <xsl:template match="gmd:URL">
-    <xsl:variable name="url"><xsl:value-of select="./text()" /></xsl:variable>
-    <xsl:element name="a">
-      <xsl:attribute name="href">
-        <xsl:value-of select="$url" />
-      </xsl:attribute>
-      <xsl:value-of select="$url" />
-    </xsl:element>
-  </xsl:template>
 </xsl:stylesheet>
\ No newline at end of file