Index: lib/style/skins/metacatui/iso19115/iso-ex.xsl
===================================================================
--- lib/style/skins/metacatui/iso19115/iso-ex.xsl	(revision 10168)
+++ lib/style/skins/metacatui/iso19115/iso-ex.xsl	(revision 10169)
@@ -1,249 +1,256 @@
 <?xml version="1.0"?>
 <xsl:stylesheet 
-  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
-  xmlns:gmd="http://www.isotc211.org/2005/gmd" 
-  xmlns:gco="http://www.isotc211.org/2005/gco" 
-  xmlns:gml="http://www.opengis.net/gml/3.2" version="1.0">
-
+    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
+    xmlns:gmd="http://www.isotc211.org/2005/gmd" 
+    xmlns:gco="http://www.isotc211.org/2005/gco" 
+    xmlns:gml="http://www.opengis.net/gml/3.2" version="1.0">
     <xsl:template match="gmd:EX_Extent">
-      <h4>Coverage</h4>
-
-      <!-- description -->
-      <xsl:if test=".//gmd:description">
-        <div class="control-group">
-          <label class="control-label">Description</label>
-          <div class="controls">
-            <div class="controls-well">
-              <xsl:apply-templates />
+        <h4>Coverage</h4>
+        <!-- description -->
+        <xsl:if test=".//gmd:description">
+            <div class="control-group">
+                <label class="control-label">Description</label>
+                <div class="controls">
+                    <div class="controls-well">
+                        <xsl:apply-templates />
+                    </div>
+                </div>
             </div>
-          </div>
-        </div>
-      </xsl:if>
+        </xsl:if>
 
-      <!-- Geographic -->
-      <xsl:for-each select=".//gmd:geographicElement">
-        <div class="row-fluid geographicCoverage">
-          <div class="control-group">
-            <label class="control-label">Geographic</label>
-            <div class="controls">
-              <div class="controls-well">
-                <xsl:apply-templates />
-              </div>
+        <!-- Geographic -->
+        <xsl:for-each select=".//gmd:geographicElement">
+            <div class="row-fluid geographicCoverage">
+                <div class="control-group">
+                    <label class="control-label">Geographic</label>
+                    <div class="controls">
+                        <div class="controls-well">
+                            <xsl:apply-templates />
+                        </div>
+                    </div>
+                </div>
             </div>
-          </div>
-        </div>
-      </xsl:for-each>
+        </xsl:for-each>
 
-      <!-- Temporal -->
-      <xsl:for-each select=".//gmd:temporalElement">
-        <div class="control-group">
-          <label class="control-label">Temporal</label>
-          <div class="controls">
-            <div class="controls-well">
-              <xsl:apply-templates />
+        <!-- Temporal -->
+        <xsl:for-each select=".//gmd:temporalElement">
+            <div class="control-group">
+                <label class="control-label">Temporal</label>
+                <div class="controls">
+                    <div class="controls-well">
+                        <xsl:apply-templates />
+                    </div>
+                </div>
             </div>
-          </div>
-        </div>
-      </xsl:for-each>
+        </xsl:for-each>
 
-      <!-- Vertical -->
-      <xsl:for-each select=".//gmd:verticalElement">
-        <div class="control-group">
-          <label class="control-label">Vertical</label>
-          <div class="controls">
-            <div class="controls-well">
-              <xsl:apply-templates />
+        <!-- Vertical -->
+        <xsl:for-each select=".//gmd:verticalElement">
+            <div class="control-group">
+                <label class="control-label">Vertical</label>
+                <div class="controls">
+                    <div class="controls-well">
+                        <xsl:apply-templates />
+                    </div>
+                </div>
             </div>
-          </div>
-        </div>
-      </xsl:for-each>
+        </xsl:for-each>
     </xsl:template>
 
-  <!-- EX_GeographicExtent-->
-  <xsl:template match="gmd:EX_GeographicExtent">
-    <xsl:apply-templates />
-  </xsl:template>
+    <!-- EX_GeographicExtent-->
+    <xsl:template match="gmd:EX_GeographicExtent">
+        <xsl:apply-templates />
+    </xsl:template>
 
-  <!-- EX_BoundingPolygon-->
-  <xsl:template match="gmd:EX_BoundingPolygon">
-    <xsl:apply-templates />
-  </xsl:template>
+    <!-- EX_BoundingPolygon-->
+    <xsl:template match="gmd:EX_BoundingPolygon">
+        <xsl:apply-templates />
+    </xsl:template>
 
-  <!-- EX_GeographicDescription-->
-  <xsl:template match="gmd:EX_GeographicDescription">
-    <xsl:apply-templates />
-  </xsl:template>
+    <!-- EX_GeographicDescription-->
+    <xsl:template match="gmd:EX_GeographicDescription">
+        <xsl:apply-templates />
+    </xsl:template>
 
+    <!-- EX_GeographicBoundingBox-->
+    <xsl:template match="gmd:EX_GeographicBoundingBox">
+        <!-- Set up variables for N E S W -->
+        <xsl:variable name="north">
+            <xsl:value-of select="./gmd:northBoundLatitude/gco:Decimal/text()" />
+        </xsl:variable>
+        <xsl:variable name="east">
+            <xsl:value-of select="./gmd:eastBoundLongitude/gco:Decimal/text()" />
+        </xsl:variable>
+        <xsl:variable name="south">
+            <xsl:value-of select="./gmd:southBoundLatitude/gco:Decimal/text()" />
+        </xsl:variable>
+        <xsl:variable name="west">
+            <xsl:value-of select="./gmd:westBoundLongitude/gco:Decimal/text()" />
+        </xsl:variable>
+        <div data-value="{$north}" data-content="northBoundingCoordinate" class="control-group northBoundingCoordinate">
+            <label class="control-label">North</label>
+            <div class="controls">
+                <div class="controls-well">
+                    <xsl:value-of select="$north" />&#xa0; degrees          
+                </div>
+            </div>
+        </div>
+        <div data-value="{$east}" data-content="eastBoundingCoordinate" class="control-group eastBoundingCoordinate">
+            <label class="control-label">East</label>
+            <div class="controls">
+                <div class="controls-well">
+                    <xsl:value-of select="$east" />&#xa0; degrees          
+                </div>
+            </div>
+        </div>
+        <div data-value="{$south}" data-content="southBoundingCoordinate" class="control-group southBoundingCoordinate">
+            <label class="control-label">South</label>
+            <div class="controls">
+                <div class="controls-well">
+                    <xsl:value-of select="$south" />&#xa0; degrees          
+                </div>
+            </div>
+        </div>
+        <div data-value="{$west}" data-content="westBoundingCoordinate" class="control-group westBoundingCoordinate">
+            <label class="control-label">West</label>
+            <div class="controls">
+                <div class="controls-well">
+                    <xsl:value-of select="$west" />&#xa0; degrees          
+                </div>
+            </div>
+        </div>
+        <xsl:apply-templates select="./gmd:extentTypeCode" />
+    </xsl:template>
 
-
-  <!-- EX_GeographicBoundingBox-->
-  <xsl:template match="gmd:EX_GeographicBoundingBox">
-    <!-- Set up variables for N E S W -->
-    <xsl:variable name="north"><xsl:value-of select="./gmd:northBoundLatitude/gco:Decimal/text()" /></xsl:variable>
-    <xsl:variable name="east"><xsl:value-of select="./gmd:eastBoundLongitude/gco:Decimal/text()" /></xsl:variable>
-    <xsl:variable name="south"><xsl:value-of select="./gmd:southBoundLatitude/gco:Decimal/text()" /></xsl:variable>
-    <xsl:variable name="west"><xsl:value-of select="./gmd:westBoundLongitude/gco:Decimal/text()" /></xsl:variable>
-
-    <div data-value="{$north}" data-content="northBoundingCoordinate" class="control-group northBoundingCoordinate">
-      <label class="control-label">North</label>
-      <div class="controls">
-          <div class="controls-well">
-              <xsl:value-of select="$north" />&#xa0; degrees
-          </div>
-      </div>
-    </div>
-
-    <div data-value="{$east}" data-content="eastBoundingCoordinate" class="control-group eastBoundingCoordinate">
-      <label class="control-label">East</label>
-      <div class="controls">
-          <div class="controls-well">
-              <xsl:value-of select="$east" />&#xa0; degrees
-          </div>
-      </div>
-    </div>
-
-    <div data-value="{$south}" data-content="southBoundingCoordinate" class="control-group southBoundingCoordinate">
-      <label class="control-label">South</label>
-      <div class="controls">
-          <div class="controls-well">
-              <xsl:value-of select="$south" />&#xa0; degrees
-          </div>
-      </div>
-    </div>
-
-    <div data-value="{$west}" data-content="westBoundingCoordinate" class="control-group westBoundingCoordinate">
-      <label class="control-label">West</label>
-      <div class="controls">
-          <div class="controls-well">
-              <xsl:value-of select="$west" />&#xa0; degrees
-          </div>
-      </div>
-    </div>
-
-    <xsl:apply-templates select="./gmd:extentTypeCode" />
-  </xsl:template>
-
-  <xsl:template match="gmd:polygon">
-    <div class="control-group">
-      <label class="control-label">Polygon</label>
-      <div class="controls">
-        <div class="controls-well">
-          <xsl:apply-templates />
+    <!-- gmd:polygon -->
+    <xsl:template match="gmd:polygon">
+        <div class="control-group">
+            <label class="control-label">Polygon</label>
+            <div class="controls">
+                <div class="controls-well">
+                    <xsl:apply-templates />
+                </div>
+            </div>
         </div>
-      </div>
-    </div>
-  </xsl:template>
+    </xsl:template>
 
-  <!-- EX_TemporalExtent -->
-  <xsl:template match="gmd:EX_TemporalExtent">
-    <xsl:apply-templates select=".//gmd:extent/*" />
-  </xsl:template>
+    <!-- EX_TemporalExtent -->
+    <xsl:template match="gmd:EX_TemporalExtent">
+        <xsl:apply-templates select=".//gmd:extent/*" />
+    </xsl:template>
 
-  <!-- EX_VerticalExtent-->
-  <!-- TODO: Improve DOM structure -->
-  <xsl:template name="verticalextent" match="gmd:EX_VerticalExtent">
-    <span>minimumValue:     
-      <xsl:value-of select="./gmd:minimumValue/gco:Real" />
-    </span>
-    <span>maximumValue:     
-      <xsl:value-of select="./gmd:maximumValue/gco:Real" />
-    </span>
-    <!-- TODO: Flesh this out a bit more -->
-    <span>verticalCRS:     
-      <xsl:value-of select="./gmd:verticalCRS" />
-    </span>
-  </xsl:template>
+    <!-- EX_VerticalExtent-->
+    <!-- TODO: Improve DOM structure -->
+    <!-- TODO: Flesh this out a bit more... -->
+    <xsl:template match="gmd:EX_VerticalExtent">
+        <span>minimumValue: 
+            <xsl:value-of select="./gmd:minimumValue/gco:Real" />
+        </span>
+        <span>maximumValue: 
+            <xsl:value-of select="./gmd:maximumValue/gco:Real" />
+        </span>
+        <span>verticalCRS: 
+            <xsl:value-of select="./gmd:verticalCRS" />
+        </span>
+    </xsl:template>
 
-  <!-- TimeInstant-->
-  <!-- TODO
+    <!-- TimeInstant-->
+    <!-- TODO
         - Attributes: frame, calendarEraName, indeterminatePosition
     -->
-  <xsl:template name="timeinstant" match="gml:TimeInstant">
-    <span>time instant</span>
-    <span>description:             
-      <xsl:value-of select=".//gmd:description" />
-    </span>
-    <span>
-      <span>timePosition:             
-        <xsl:value-of select=".//gml:timePosition" />
-      </span>
-      <xsl:if test=".//gml:timePosition/@calendarEraName">
-        <span>
-          <xsl:value-of select=".//gml:timePosition/@calendarEraName" /> (calendarEraName)
+    <xsl:template match="gml:TimeInstant">
+        <span>time instant</span>
+        <span>description:
+            <xsl:value-of select=".//gmd:description" />
         </span>
-      </xsl:if>
-      <xsl:if test=".//gml:timePosition/@indeterminatePosition">
-        <span>
-          <xsl:value-of select=".//gml:timePosition/@indeterminatePosition" /> (indeterminatePosition)
-        </span>
-      </xsl:if>
-    </span>
-  </xsl:template>
+        <div>
+            <span>timePosition:
+                <xsl:value-of select=".//gml:timePosition" />
+            </span>
+            <xsl:if test=".//gml:timePosition/@calendarEraName">
+                <span>
+                    <xsl:value-of select=".//gml:timePosition/@calendarEraName" /> (calendarEraName)
+                </span>
+            </xsl:if>
+            <xsl:if test=".//gml:timePosition/@indeterminatePosition">
+                <span>
+                    <xsl:value-of select=".//gml:timePosition/@indeterminatePosition" /> (indeterminatePosition)
+                </span>
+            </xsl:if>
+        </div>
+    </xsl:template>
 
-  <!-- TimePeriod-->
-  <!-- TODO: 
+    <!-- TimePeriod-->
+    <!-- TODO: 
         - All the attributes
         - timeInterval units, radix, factor
     -->
-  <xsl:template name="timeperiod" match="gml:TimePeriod">
+    <xsl:template match="gml:TimePeriod">
+        <xsl:if test=".//gml:beginPosition">
+            <div class="control-group">
+                <label class="control-label">Begin</label>
+                <div class="controls">
+                    <span>
+                        <xsl:value-of select=".//gml:beginPosition" />
+                    </span>
+                    <xsl:if test=".//gml:beginPosition/@calendarEraName">
+                        <span>
+                            <xsl:value-of select=".//gml:beginPosition/@calendarEraName" /> (calendarEraName)
+                        </span>
+                    </xsl:if>
+                    <xsl:if test=".//gml:beginPosition/@indeterminatePosition">
+                        <span>
+                            <xsl:value-of select=".//gml:beginPosition/@indeterminatePosition" /> (indeterminatePosition)
+                        </span>
+                    </xsl:if>
+                </div>
+            </div>
+        </xsl:if>
+        <xsl:if test=".//gml:endPosition">
+            <div class="control-group">
+                <label class="control-label">End</label>
+                <div class="controls">
+                    <span>
+                        <xsl:value-of select=".//gml:endPosition" />
+                    </span>
+                    <xsl:if test=".//gml:endPosition/@calendarEraName">
+                        <span>
+                            <xsl:value-of select=".//gml:endPosition/@calendarEraName" /> (calendarEraName)
+                        </span>
+                    </xsl:if>
+                    <xsl:if test=".//gml:endPosition/@indeterminatePosition">
+                        <span>
+                            <xsl:value-of select=".//gml:endPosition/@indeterminatePosition" /> (indeterminatePosition)
+                        </span>
+                    </xsl:if>
+                </div>
+            </div>
+        </xsl:if>
+        <xsl:if test=".//gml:duration">
+            <span>duration:
+                <xsl:value-of select=".//gml:duration" />
+            </span>
+        </xsl:if>
+        <xsl:if test=".//gml:timeInterval">
+            <span>timeInterval:
+                <xsl:value-of select=".//gml:timeInterval" />
+            </span>
+        </xsl:if>
+    </xsl:template>
 
-
-
-
-    <xsl:if test=".//gml:beginPosition">
-      <div class="control-group">
-        <label class="control-label">Begin</label>
-        <div class="controls">
-          <span><xsl:value-of select=".//gml:beginPosition" /></span>
-          <xsl:if test=".//gml:beginPosition/@calendarEraName">
-            <span><xsl:value-of select=".//gml:beginPosition/@calendarEraName" /> (calendarEraName)</span>                        
-          </xsl:if>
-          <xsl:if test=".//gml:beginPosition/@indeterminatePosition">
-            <span><xsl:value-of select=".//gml:beginPosition/@indeterminatePosition" /> (indeterminatePosition)</span>                        
-          </xsl:if>
+    <!-- extentTypeCode -->
+    <xsl:template match="gmd:extentTypeCode">
+        <div class="control-group extentTypeCode">
+            <label class="control-label">Type</label>
+            <div class="controls">
+                <xsl:choose>
+                    <xsl:when test="./gco:Boolean = 0">Exclusive</xsl:when>
+                    <xsl:when test="./gco:Boolean = 1">Inclusive</xsl:when>
+                    <xsl:when test="./@nilReason">
+                        <xsl:value-of select="./@nilReason" />
+                    </xsl:when>
+                </xsl:choose>
+            </div>
         </div>
-      </div>
-    </xsl:if>
-
-    <xsl:if test=".//gml:endPosition">
-      <div class="control-group">
-        <label class="control-label">End</label>
-        <div class="controls">
-          <span><xsl:value-of select=".//gml:endPosition" /></span>
-          <xsl:if test=".//gml:endPosition/@calendarEraName">
-            <span><xsl:value-of select=".//gml:endPosition/@calendarEraName" /> (calendarEraName)</span>                        
-          </xsl:if>
-          <xsl:if test=".//gml:endPosition/@indeterminatePosition">
-            <span><xsl:value-of select=".//gml:endPosition/@indeterminatePosition" /> (indeterminatePosition)</span>                        
-          </xsl:if>
-        </div>
-      </div>
-    </xsl:if>
-
-    <xsl:if test=".//gml:duration">
-        <span>duration:         
-        <xsl:value-of select=".//gml:duration" />
-      </span>
-    </xsl:if>
-
-    <xsl:if test=".//gml:timeInterval">
-      <span>timeInterval:         
-        <xsl:value-of select=".//gml:timeInterval" />
-      </span>
-    </xsl:if>
-  </xsl:template>
-
-  <!-- extentTypeCode -->
-  <xsl:template match="gmd:extentTypeCode">
-    <div class="control-group extentTypeCode">
-      <label class="control-label">Type</label>
-      <div class="controls">
-        <xsl:choose>
-          <xsl:when test="./gco:Boolean = 0">Exclusion</xsl:when>
-          <xsl:when test="./gco:Boolean = 1">Inclusion</xsl:when>
-          <xsl:when test="./@nilReason"><xsl:value-of select="./@nilReason" /></xsl:when>
-        </xsl:choose>
-      </div>
-    </div>
-  </xsl:template>
+    </xsl:template>
 </xsl:stylesheet>
\ No newline at end of file
Index: lib/style/skins/metacatui/iso19115/isoroot.xsl
===================================================================
--- lib/style/skins/metacatui/iso19115/isoroot.xsl	(revision 10168)
+++ lib/style/skins/metacatui/iso19115/isoroot.xsl	(revision 10169)
@@ -3,7 +3,8 @@
     xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
     xmlns:gmd="http://www.isotc211.org/2005/gmd" 
     xmlns:gco="http://www.isotc211.org/2005/gco" 
-    xmlns:xlink="http://www.w3.org/1999/xlink" version="1.0">
+    version="1.0">
+
     <xsl:import href="iso-md.xsl"/>
     <xsl:import href="iso-ci.xsl"/>
     <xsl:import href="iso-ex.xsl"/>
@@ -11,11 +12,18 @@
     <xsl:import href="iso-gmd.xsl"/>
     <xsl:import href="iso-gml.xsl"/>
     <xsl:import href="iso-gmx.xsl"/>
-    <xsl:output method="html" encoding="UTF-8" doctype-public="-//W3C//DTD XHTML 1.0 Transitional//EN" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd" indent="yes" />
+
+    <xsl:output method="html"
+                encoding="UTF-8"
+                doctype-public="-//W3C//DTD XHTML 1.0 Transitional//EN"
+                doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"
+                indent="yes" />
+
     <!-- TODO: Figure out how to set the output method to get what I want -->
     <!-- TODO: ^ Figure out what I want to output -->
     <!-- TODO: Figuer out what this match statement should have in it -->
     <!-- TODO: Cover gmd:identificationInfo/SV_ServiceIdentification -->
+
     <xsl:template match="*[local-name()='MD_Metadata'] | *[local-name()='MI_Metadata']">
         <form class="form-horizontal">
             <div class="control-group entity">
@@ -29,8 +37,10 @@
                         </div>
                     </div>
                 </div>
+
                 <!-- TODO: language 1:1 -->
                 <!-- TODO: characterSet 1:1 -->
+
                 <!-- Parent Identifier 1:1 conditional -->
                 <xsl:if test="//gmd:parentIdentifier">
                     <div class="control-group">
@@ -42,10 +52,12 @@
                         </div>
                     </div>
                 </xsl:if>
+
                 <!-- TODO: hierarchyLevel 0:inf -->
                 <!-- TODO: hierarchyLevelName 0:inf -->
+
                 <!-- Alternate identifier(s) 0:inf-->
-                <!-- gmd:identifier is an optional aprt of the CI_Citation element -->
+                <!-- gmd:identifier is an optional part of the CI_Citation element -->
                 <xsl:for-each select="//gmd:identificationInfo/gmd:MD_DataIdentification/gmd:citation/gmd:CI_Citation/gmd:identifier">
                     <div class="control-group">
                         <label class="control-label">Cited Identifier</label>
@@ -56,6 +68,7 @@
                         </div>
                     </div>
                 </xsl:for-each>
+
                 <!-- Abstract 1:inf-->
                 <xsl:for-each select="//gmd:identificationInfo/gmd:MD_DataIdentification/gmd:abstract">
                     <div class="control-group">
@@ -67,6 +80,7 @@
                         </div>
                     </div>
                 </xsl:for-each>
+
                 <!-- Publication (dateStamp) date 1:1 -->
                 <div class="control-group">
                     <label class="control-label">Publication Date</label>
@@ -76,7 +90,8 @@
                         </div>
                     </div>
                 </div>
-                <!--  Topic Categories -->
+
+                <!-- Topic Categories -->
                 <xsl:if test="//gmd:topicCategory">
                     <div class="control-group">
                         <label class="control-label">Topic Categories</label>
@@ -102,11 +117,12 @@
                         </div>
                     </div>
                 </xsl:if>
+
                 <!-- Keywords
 
-            Each <gmd:descriptiveKeywords> block should have one or more keywords in it
-            with one thesaurus. So we render keywords from the same thesaurus together.
-        -->
+                Each <gmd:descriptiveKeywords> block should have one or more keywords in it
+                with one thesaurus. So we render keywords from the same thesaurus together.
+                -->
                 <xsl:if test="//gmd:descriptiveKeywords">
                     <div class="control-group">
                         <label class="control-label">Descriptive Keywords</label>
@@ -120,6 +136,7 @@
                     </div>
                 </xsl:if>
             </div>
+
             <div class="control-group entity">
                 <h4>People and Associated Parties</h4>
                 <!-- Metadata Contact(s) 1:inf -->
@@ -133,6 +150,7 @@
                         </div>
                     </div>
                 </div>
+
                 <!-- Data Set Contact(s) -->
                 <div class="control-group">
                     <label class="control-label">Data Set Contacts</label>
@@ -142,6 +160,7 @@
                         </div>
                     </div>
                 </div>
+
                 <!-- Cited responsible parties-->
                 <div class="control-group">
                     <label class="control-label">Associated Parties</label>
@@ -165,7 +184,9 @@
             <xsl:for-each select="//gmd:identificationInfo/gmd:MD_DataIdentification/gmd:extent">
                 <xsl:apply-templates />
             </xsl:for-each>
+
             <!-- TODO Methods -->
+
             <div class="control-group entity">
                 <h4>Other Information</h4>
                 <!-- Data usage rights (resourceConstraints) -->
@@ -177,11 +198,12 @@
             </div>
         </form>
     </xsl:template>
+
     <!-- General, high-level templates -->
     <!-- TODO: Figure out how to do this: I want to capture the scenario where
-  an element like gmd:individualName has no child gco:CharacterString or 
-  equivalent but has a nilReason attribute. -->
-    <xsl:template match="*[not(*) and ./@nilReason]">    nilReason!            
+    an element like gmd:individualName has no child gco:CharacterString or
+    equivalent but has a nilReason attribute. -->
+    <xsl:template match="*[not(*) and ./@nilReason]">
         <xsl:value-of select="@nilReason" />
     </xsl:template>
 </xsl:stylesheet>
\ No newline at end of file